/*
 * box.c
 *
 * Last modified: <2008/08/09 09:27:32 +0900> By SUMIDA
 */
#include <SDL.h>
#include <math.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "item.h"
#include "effect.h"
#include "radian.h"

#define FLAG_ITEM_CREATE  0x0001
#define ITEM_MAX          3
#define ITEM_SPEED        3.5
#define ITEM_INTERVAL     15
#define ANGLE_BASE        15

extern SHIP_MGR enemy_mgr;

void box_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = ToReal(1.5);
}

void box(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_EXPLOSION:
		/* ACe𐶐ĂȂꍇAPx */
		if (!(info->flag & FLAG_ITEM_CREATE)) {
			Real x = info->sprite.x + IntToReal(54);
			Real y = info->sprite.y + IntToReal(24);
			int i;

			for (i = 0; i < ITEM_MAX; i++) {

				int id = ((ship->flag & ITEM_FLAG_MASK) == ITEM_FLAG_MASK) ?
				ITEM_ID_CHANGE: (int)Random(SHIP_ID_ITEM, SHIP_ID_BONUS);

				SHIP_INFO *item = enemy_new(&enemy_mgr, id, x, y);

				if (item != NULL) {
					double angle = DegToRad(ANGLE_BASE + i * ITEM_INTERVAL);
					item->sprite.dx = ToReal(sin(angle) * ITEM_SPEED);
					item->sprite.dy = ToReal(-cos(angle) * ITEM_SPEED);
				}
			}

			info->flag |= FLAG_ITEM_CREATE;
		}
		break;

	default:
		info->sprite.dy = ToReal(cos(info->count/10));
		break;
	}
}

void box_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}

