/*
 * enemy.c
 *
 * Last modified: <2008/10/18 14:58:44 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "item.h"

extern SHIP_MGR enemy_mgr;
extern SHOT_MGR enemy_shot_mgr;
extern SHOT_INFO enemy_shot[ENEMY_SHOT_MAX];

extern void enemy1_init(SHIP_INFO *info);
extern void enemy2_init(SHIP_INFO *info);
extern void enemy3_init(SHIP_INFO *info);
extern void enemy4_init(SHIP_INFO *info);
extern void enemy5_init(SHIP_INFO *info);
extern void enemy6_init(SHIP_INFO *info);
extern void enemy7_init(SHIP_INFO *info);
extern void enemy8_init(SHIP_INFO *info);
extern void enemy9_init(SHIP_INFO *info);
extern void boss1_init(SHIP_INFO *info);
extern void boss2_init(SHIP_INFO *info);
extern void boss2_horn_init(SHIP_INFO *info);
extern void axe_init(SHIP_INFO *info);
extern void parachute_init(SHIP_INFO *info);
extern void box_init(SHIP_INFO *info);
extern void snowflake_init(SHIP_INFO *info);
extern void fire_init(SHIP_INFO *info);
extern void ring_init(SHIP_INFO *info);
extern void item_init(SHIP_INFO *info);

extern void enemy1(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy2(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy3(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy4(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy5(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy6(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy7(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy8(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void enemy9(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void boss1(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void boss2(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void boss2_horn(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void axe(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void parachute(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void box(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void snowflake(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void fire(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void ring(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);
extern void item(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship);

extern void enemy1_term(SHIP_INFO *info);
extern void enemy2_term(SHIP_INFO *info);
extern void enemy3_term(SHIP_INFO *info);
extern void enemy4_term(SHIP_INFO *info);
extern void enemy5_term(SHIP_INFO *info);
extern void enemy6_term(SHIP_INFO *info);
extern void enemy7_term(SHIP_INFO *info);
extern void enemy8_term(SHIP_INFO *info);
extern void enemy9_term(SHIP_INFO *info);
extern void boss1_term(SHIP_INFO *info);
extern void boss2_term(SHIP_INFO *info);
extern void boss2_horn_term(SHIP_INFO *info);
extern void axe_term(SHIP_INFO *info);
extern void parachute_term(SHIP_INFO *info);
extern void box_term(SHIP_INFO *info);
extern void snowflake_term(SHIP_INFO *info);
extern void fire_term(SHIP_INFO *info);
extern void ring_term(SHIP_INFO *info);
extern void item_term(SHIP_INFO *info);

void(*func_enemy_init[])(SHIP_INFO*) = {
	enemy1_init,
	enemy2_init,
	enemy3_init,
	enemy4_init,
	enemy5_init,
	enemy6_init,
	enemy7_init,
	enemy8_init,
	enemy9_init,
	axe_init,
	parachute_init,
	box_init,
	snowflake_init,
	fire_init,
	ring_init,
	boss2_horn_init,
	boss2_horn_init,
	boss2_horn_init,
	boss2_horn_init,
	boss1_init,
	boss2_init,
	item_init,
	item_init,
	item_init,
	item_init,
	item_init,
	item_init,
	item_init,
};

void(*func_enemy[])(SHIP_INFO*, SHOT_MGR*, SHIP_INFO*) = {
	enemy1,
	enemy2,
	enemy3,
	enemy4,
	enemy5,
	enemy6,
	enemy7,
	enemy8,
	enemy9,
	axe,
	parachute,
	box,
	snowflake,
	fire,
	ring,
	boss2_horn,
	boss2_horn,
	boss2_horn,
	boss2_horn,
	boss1,
	boss2,
	item,
	item,
	item,
	item,
	item,
	item,
	item,
};

void(*func_enemy_term[])(SHIP_INFO*) = {
	enemy1_term,
	enemy2_term,
	enemy3_term,
	enemy4_term,
	enemy5_term,
	enemy6_term,
	enemy7_term,
	enemy8_term,
	enemy9_term,
	axe_term,
	parachute_term,
	box_term,
	snowflake_term,
	fire_term,
	ring_term,
	boss2_horn_term,
	boss2_horn_term,
	boss2_horn_term,
	boss2_horn_term,
	boss1_term,
	boss2_term,
	item_term,
	item_term,
	item_term,
	item_term,
	item_term,
	item_term,
	item_term,
};

SHIP_INFO *enemy_new(SHIP_MGR *mgr, SHIP_ID id, Real x, Real y) {

	SHIP_INFO *info = ship_new(mgr, id);

	if (info != NULL) {

		info->stat     = SHIP_STAT_APPEAR;
		info->count    = 10;
		info->sprite.x = x;
		info->sprite.y = y;

		func_enemy_init[id - SHIP_ID_ENEMY](info);
	}

	return info;
}

SHIP_INFO *enemy_child_new(SHIP_MGR *mgr, SHIP_ID id, SHIP_INFO *parent) {

	SHIP_INFO *info = ship_child_new(mgr, id, parent);

	if (info != NULL) {

		info->stat     = SHIP_STAT_APPEAR;
		info->count    = 10;

		func_enemy_init[id - SHIP_ID_ENEMY](info);
	}

	return info;
}

void enemy_action(SHIP_MGR *mgr, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	SHIP_INFO *info = mgr->active;

	while (info != NULL) {

		sprite_action(&info->sprite);

		if (!(info->flag & SHIP_FLAG_NOCLIP)) {
			SURFACE *surface = surface_get(info->sprite.surface_id);

			int x0 = RealToInt(info->sprite.x);
			int y0 = RealToInt(info->sprite.y);
			int x1 = x0 + surface->frame_width  -1;
			int y1 = y0 + surface->frame_height -1;

			if (x0 > CLIP_X1 || x1 < CLIP_X0 || y0 > CLIP_Y1 || y1 < CLIP_Y0) {
				SHIP_INFO *next = info->next;
				REPORT(format("delete(info=%p, id=%d, x0=%d, y0=%d, x1=%d, y1=%d)", info, info->id, x0, y0, x1, y1));
				ship_delete(mgr, info);
				info = next;
				continue;
			}
		}

		/* JE^̃fNg */
		--info->count;

		/* Ԗ̏s */
		switch (info->stat) {
		case SHIP_STAT_APPEAR:
		case SHIP_STAT_NORMAL:
		case SHIP_STAT_MOVE:
		case SHIP_STAT_FIRE:
			if (sprite_collision_check(&info->sprite, &ship->sprite) == SDL_TRUE) {
				if (info->flag & SHIP_FLAG_ITEM) {
					item_action(info);
					info->stat = SHIP_STAT_LOST;
				} else {
					ship_down(ship, &info->strength, info->sprite.dx >> 2, info->sprite.dy >> 2);
				}
			}

		default:
			if (info->stat == SHIP_STAT_EXPLOSION && info->count < 0) {
				info->stat = SHIP_STAT_LOST;
			}
			func_enemy[info->id - SHIP_ID_ENEMY](info, shot_mgr, ship);
			break;
		}

		if (info->stat == SHIP_STAT_LOST) {
			/* 폜 */
			SHIP_INFO *next = info->next;
			func_enemy_term[info->id - SHIP_ID_ENEMY](info);
			REPORT(format("delete(info=%p, id=%d)", info, info->id));
			ship_delete(mgr, info);
			info = next;

		} else {
			/* eԂ  */
			info->flag &= ~SHIP_FLAG_DOWN;

			/* \ */
			sprite_put(&info->sprite);

			info = info->next;
		}
	}
}

void enemy_explosion(void) {

	SHIP_INFO *enemy;
	SHOT_INFO *shot;

	for (enemy = enemy_mgr.active; enemy != NULL; enemy = enemy->next) {

		if (enemy->id < ITEM_ID_CHANGE
			&& enemy->stat != SHIP_STAT_LOST
			&& enemy->stat != SHIP_STAT_EXPLOSION) {

			int strength = 9999;
			ship_down(enemy, &strength, 0, 0);
		}
	}

	for (shot = enemy_shot_mgr.active; shot != NULL; shot = shot->next) {

		EFFECT_INFO *effect = effect_new(EFFECT_ID_HIT);

		if (effect != NULL) {
			effect_set_pos(effect, &shot->sprite, 0, 0);
			effect->sprite.dx = ToReal(Random(-2.5, 4));
			effect->sprite.dy = ToReal(Random(-2.5, 2.5));
		}
	}

	shot_init(&enemy_shot_mgr, enemy_shot, NUMBEROF(enemy_shot));
}
