/*
 * enemy5.c
 *
 * Last modified: <2008/08/08 08:43:21 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

extern SHIP_MGR enemy_mgr;

void enemy5_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = IntToReal(1);
}

void enemy5(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		/* @ɕύX */
		if (info->sprite.y < ship->sprite.y && info->sprite.dy < 0
			|| info->sprite.y > ship->sprite.y && info->sprite.dy > 0) {

			info->sprite.dy = -info->sprite.dy;
		}

		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			info->count = 10;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0 && Random(0, 128) < system_info.level) {
			/* 3way */

			/* @Zo */
			double angle = sprite_get_angle(&info->sprite, &ship->sprite);
			SHOT_INFO *shot1 = shot_new(shot_mgr, SHOT_ID_BALLET);
			SHOT_INFO *shot2 = shot_new(shot_mgr, SHOT_ID_BALLET);
			SHOT_INFO *shot3 = shot_new(shot_mgr, SHOT_ID_BALLET);

			if (shot1 != NULL) {
				shot_fire(shot1, info, 0, 0);
				sprite_set_angle(&shot1->sprite, angle, IntToReal(2));
			}
			if (shot2 != NULL) {
				shot_fire(shot2, info, 0, 0);
				sprite_set_angle(&shot2->sprite, angle - 15, IntToReal(2));
			}
			if (shot3 != NULL) {
				shot_fire(shot3, info, 0, 0);
				sprite_set_angle(&shot3->sprite, angle + 15, IntToReal(2));
			}

			info->count = 10;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}
}

void enemy5_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
