/*
 * enemy6.c
 *
 * Last modified: <2008/08/08 08:43:06 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

void enemy6_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = IntToReal(1);
}

void enemy6(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 40;
			info->stat = SHIP_STAT_NORMAL;
			info->sprite.dy = ToReal(-2);
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0) {
			info->count = 40;

			if (Random(0, 16) < system_info.level) {
				info->sprite.dy = ToReal(-2);
				info->stat = SHIP_STAT_FIRE;
			} else {
				info->stat = SHIP_STAT_MOVE;
			}
		}
		break;

	case SHIP_STAT_FIRE:
		if (info->count < 0) {
			/* _Pe̔ */
			SHOT_INFO *shot = shot_new(shot_mgr, SHOT_ID_BALLET);

			if (shot != NULL) {
				shot_fire(shot, info, 0, 0);
				shot_homing(&shot->sprite, &ship->sprite, IntToReal(1));
			}

			info->count = 10;
			info->stat = SHIP_STAT_MOVE;
			info->sprite.dy = 0;
		}
		break;

	default:
		return;
	}

	info->sprite.dy += ToReal(0.05);

	/* ʒ[Ŕ] */
	if (info->sprite.dy < 0 && info->sprite.y < IntToReal(10)
		|| info->sprite.dy > 0 && info->sprite.y > IntToReal(HEIGHT - 10)) {
		info->sprite.dy = -info->sprite.dy;
	}
}

void enemy6_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
