/*
 * enemy7.c
 *
 * Last modified: <2008/08/30 01:02:46 +0900> By SUMIDA
 */
#include <SDL.h>
#include "system.h"
#include "texture.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "sound.h"

extern SHIP_MGR enemy_mgr;

void enemy7_init(SHIP_INFO *info) {

	REPORT(format("info=%p, id=%d", info, info->id));
	info->sprite.dx = IntToReal(1);
}

void enemy7(SHIP_INFO *info, SHOT_MGR *shot_mgr, SHIP_INFO *ship) {

	switch (info->stat) {
	case SHIP_STAT_APPEAR:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	case SHIP_STAT_MOVE:
		if (info->count < 0) {
			info->count = 5;
			info->stat = SHIP_STAT_NORMAL;
		}
		break;

	case SHIP_STAT_NORMAL:
		if (info->count < 0 && Random(-1, 128) < system_info.level) {
			info->count = 5;
			info->stat = SHIP_STAT_FIRE;
		}
		break;

	/* TODO : UjG@𓮍B */
	case SHIP_STAT_FIRE:
		if (info->count < 0) {
			/* _Ήe̔ */
			SHIP_INFO *fire = enemy_new(&enemy_mgr, SHIP_ID_FIRE,
										info->sprite.x + IntToReal(56-4),
										info->sprite.y + IntToReal(100-4));

			if (fire != NULL) {
				shot_homing(&fire->sprite, &ship->sprite, IntToReal(1));
			}

			info->count = 10;
			info->stat = SHIP_STAT_MOVE;
		}
		break;

	default:
		return;
	}

	/* ʒ[Ŕ] */
	if (info->sprite.dy < 0 && info->sprite.y < IntToReal(10)
		|| info->sprite.dy > 0 && info->sprite.y > IntToReal(HEIGHT - 10)) {
		info->sprite.dy = -info->sprite.dy;
	}
}

void enemy7_term(SHIP_INFO *info) {
	REPORT(format("info=%p", info));
}
