/*
 * sample3.c
 *
 * Last modified: <2008/12/08 00:48:35 +0900> By SUMIDA
 */
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <SDL.h>
#include <SDL_image.h>
#include "system.h"
#include "texture.h"
#include "surface.h"
#include "sprite.h"
#include "bg.h"
#include "input.h"
#include "ship.h"
#include "shot.h"
#include "enemy.h"
#include "effect.h"
#include "map.h"
#include "sound.h"
#include "myship.h"
#include "item.h"

int WIDTH  = DEF_WIDTH;
int HEIGHT = DEF_HEIGHT;

SDL_Surface *screen = NULL;
SystemInfo system_info;

MYSHIP_MGR myship_mgr;

SHIP_MGR  ship_mgr;
SHIP_MGR  enemy_mgr;
SHOT_MGR  ship_shot_mgr;
SHOT_MGR  ship_shot2_mgr;
SHOT_MGR  ship_shot3_mgr;
SHOT_MGR  ship_missile_mgr;
SHOT_MGR  enemy_shot_mgr;

SHIP_INFO ships[SHIP_MAX];
SHIP_INFO enemy[ENEMY_MAX];
SHOT_INFO ship_shot[SHIP_SHOT_MAX];
SHOT_INFO ship_shot2[SHIP_SHOT2_MAX];
SHOT_INFO ship_shot3[SHIP_SHOT3_MAX];
SHOT_INFO ship_missile[SHIP_MISSILE_MAX];
SHOT_INFO enemy_shot[ENEMY_SHOT_MAX];

static void background_init(void);
static void system_info_draw(SDL_Surface* screen);
static void restart(void);

/* B
 * Ƃ0AsƂ-1ԂB
 */
int Initialize(void) {

	int i;

	/*  */
	srand(time(NULL));

	/* SDL */
#ifdef USE_AUDIO
	if (SDL_Init(SDL_INIT_VIDEO| SDL_INIT_AUDIO|SDL_INIT_TIMER|SDL_INIT_JOYSTICK) < 0) { /* Normal */
#else
	if (SDL_Init(SDL_INIT_VIDEO| SDL_INIT_TIMER|SDL_INIT_JOYSTICK) < 0) { /* PC1    */
#endif
		fprintf(stderr, "SDL̏Ɏs܂F%s\n", SDL_GetError());
		return -1;
	}
	printf("SDL_Init ... done.\n");

	/* ʂ̃^CgύX */
	printf("SDL_WM_SetCaption ... ");
	SDL_WM_SetCaption("My SDL Sample Game", NULL);
	printf("done.\n");

	/* ʂ */
	printf("SDL_SetVideoMode ... ");
	if (system_info.options & SYSTEM_OPT_WIDESCREEN) WIDTH = WIDE_WIDTH;
	screen = SDL_SetVideoMode(WIDTH, HEIGHT, DEPTH,
							  (system_info.options & SYSTEM_OPT_FULLSCREEN) ?
							  SDL_FULLSCREEN|SDL_HWSURFACE|SDL_DOUBLEBUF:
							  SDL_SWSURFACE);
	if (screen == NULL) {
		fprintf(stderr, "ʂ̏Ɏs܂F%s\n", SDL_GetError());
		SDL_Quit();
		return -1;
	}
	printf("done.\n");

#ifdef USE_AUDIO
	/*
	 * I[fBI
	 * open 44.1KHz, signed 16bit, system byte order,
	 *      stereo audio, using 4096 byte chunks
	 */
	printf("Mix_OpenAudio ... ");
	if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 4096) < 0) {
		fprintf(stderr, "I[fBȈɎs܂F%s\n", SDL_GetError());
		SDL_Quit();
		return -1;
	}
	printf("done.\n");
#endif

	printf("SDL_ShowCursor ... ");
	SDL_ShowCursor(SDL_DISABLE);
	printf("done.\n");

	input_init();
	surface_init();
	sprite_init();
	bg_init();
	effect_init();
	sound_init();

	/* eNX`֘At@C̐ݒ */
	surface_load("image/font8x8.png", TEX_FONT);
	surface_load("image/tree.png", TEX_BG1);
	surface_load("image/mountain.png", TEX_BG2);
	surface_load("image/sky.png", TEX_BG3);

	surface_load("image/title.png", TEX_TITLE);
	surface_load("image/gameover.png", TEX_GAMEOVER);
	surface_load("image/pause.png", TEX_PAUSE);

	surface_load("image/explosion.png", TEX_EXPLOSION);
	surface_set_frame(TEX_EXPLOSION, 64, 64);
	surface_load("image/bomb.png", TEX_BOMB);
	surface_set_frame(TEX_BOMB, 240, 240);
	surface_load("image/disperse.png", TEX_DISPERSE);
	surface_set_frame(TEX_DISPERSE, 96, 96);
	surface_load("image/hit.png", TEX_HIT);
	surface_set_frame(TEX_HIT, 32, 32);
	surface_load("image/hit2.png", TEX_HIT2);
	surface_set_frame(TEX_HIT2, 32, 32);
	surface_load("image/powerup.png", TEX_POWERUP);
	surface_set_frame(TEX_POWERUP, 96, 96);

	surface_load("image/mon_100.png", TEX_ANGEL);
	surface_load("image/shot.png"   , TEX_SHOT);
	surface_set_frame(TEX_SHOT, 32  , 32);
	surface_load("image/shot2.png"  , TEX_SHOT2);
	surface_set_frame(TEX_SHOT2, 32 , 32);
	surface_load("image/missile.png", TEX_MISSILE);
	surface_load("image/stars1.png" , TEX_STARS1);
	surface_load("image/stars2.png" , TEX_STARS2);

#ifdef FOR_1KSP
	surface_load("image/ruby.png"   , TEX_RUBY);
	surface_load("image/rails.png"  , TEX_RAILS);
	surface_load("image/java.png"   , TEX_JAVA);
	surface_load("image/python.png" , TEX_PYTHON);
#else
	surface_load("image/item_powerup.png", TEX_ITEM_POWERUP);
	surface_load("image/item_speedup.png", TEX_ITEM_SPEEDUP);
	surface_load("image/item_missile.png", TEX_ITEM_MISSILE);
	surface_load("image/item_3way.png"   , TEX_ITEM_3WAY);
#endif
	surface_load("image/star.png"   , TEX_STAR);
	surface_load("image/star2.png"  , TEX_STAR2);

#ifdef FOR_1KSP
	surface_load("image/icon_ruby.png"   , TEX_ICON_RUBY);
	surface_load("image/icon_rails.png"  , TEX_ICON_RAILS);
	surface_load("image/icon_java.png"   , TEX_ICON_JAVA);
	surface_load("image/icon_python.png" , TEX_ICON_PYTHON);
#else
	surface_load("image/icon_powerup.png", TEX_ICON_POWERUP);
	surface_load("image/icon_speedup.png", TEX_ICON_SPEEDUP);
	surface_load("image/icon_missile.png", TEX_ICON_MISSILE);
	surface_load("image/icon_3way.png"   , TEX_ICON_3WAY);
#endif
	surface_load("image/mon_020.png", TEX_ENEMY1);
	surface_load("image/mon_012.png", TEX_ENEMY2);
	surface_load("image/mon_186.png", TEX_ENEMY3);
	surface_load("image/mon_208.png", TEX_ENEMY4);
	surface_load("image/mon_263.png", TEX_ENEMY5);

	surface_load("image/mon_259.png", TEX_ENEMY6);
	surface_load("image/mon_251.png", TEX_ENEMY7);

	surface_load("image/mon_227.png", TEX_ENEMY8);
	surface_load("image/mon_183.png", TEX_ENEMY9);

	surface_load("image/mon_053.png", TEX_AXE);
	surface_load("image/mon_182r.png", TEX_PARACHUTE);
	surface_load("image/93.png"     , TEX_BOX);

	surface_load("image/69.png"     , TEX_BOSS1);
	surface_load("image/vyi0.png"   , TEX_BOSS2);

	surface_load("image/vyi1.png"   , TEX_BOSS2_HORN1);
	surface_load("image/vyi2.png"   , TEX_BOSS2_HORN2);
	surface_load("image/vyi3.png"   , TEX_BOSS2_HORN3);
	surface_load("image/vyi4.png"   , TEX_BOSS2_HORN4);

	surface_load("image/ring.png"   , TEX_RING);
	surface_set_frame(TEX_RING, 96, 64);
	surface_load("image/wave.png"   , TEX_WAVE);
	surface_set_frame(TEX_WAVE, 27, 128);

	surface_load("image/ballet.png", TEX_BALLET);
	surface_set_frame(TEX_BALLET, 8, 8);
	surface_load("image/snowflake.png", TEX_SNOWFLAKE);
	surface_load("image/fire.png", TEX_FIRE);
	surface_set_frame(TEX_FIRE, 56, 56);
	surface_load("image/ray1.png", TEX_RAY1);
	surface_load("image/ray2.png", TEX_RAY2);
	surface_load("image/photon.png", TEX_PHOTON);
	surface_set_frame(TEX_PHOTON, 88, 88);

	/* y֘At@C̐ݒ */
	sound_load_music("sound/track010_scramble_ver2.mp3", BGM_SCRAMBLE);
	sound_load_music("sound/Loop_07.mp3" , BGM_01);
	sound_load_music("sound/Loop_113.mp3", BGM_02);
	sound_load_music("sound/Loop_26.mp3" , BGM_03);
	sound_load_effect("sound/tm2_shoot000.wav", SE_SHOT0);
	sound_load_effect("sound/tm2_shoot001.wav", SE_SHOT1);
	sound_load_effect("sound/tm2_sonic000.wav", SE_SHOT2);
	sound_load_effect("sound/tm2_bom001.wav"  , SE_BOMB0);
	sound_load_effect("sound/tm2r_bom26_c.wav", SE_BOMB1);
	sound_load_effect("sound/tm2r_bom31_b.wav", SE_BOMB2);

	/* e}l[W̏ */
	ship_init(&ship_mgr, ships, NUMBEROF(ships));
	ship_init(&enemy_mgr, enemy, NUMBEROF(enemy));

	shot_init(&ship_shot_mgr, ship_shot, NUMBEROF(ship_shot));
	shot_init(&ship_shot2_mgr, ship_shot2, NUMBEROF(ship_shot2));
	shot_init(&ship_shot3_mgr, ship_shot3, NUMBEROF(ship_shot3));
	shot_init(&ship_missile_mgr, ship_missile, NUMBEROF(ship_missile));
	shot_init(&enemy_shot_mgr, enemy_shot, NUMBEROF(enemy_shot));

	memset(&myship_mgr, 0, sizeof(myship_mgr));
	myship_mgr.ship_mgr  = &ship_mgr;
	myship_mgr.shot_mgr  = &ship_shot_mgr;
	myship_mgr.shot2_mgr = &ship_shot2_mgr;
	myship_mgr.shot3_mgr = &ship_shot3_mgr;
	myship_mgr.missile_mgr = &ship_missile_mgr;

	system_info.status |= SYSTEM_MODE_READY;

	/* @̐ݒ */
	myship_init(&myship_mgr);
	myship_mgr.ship->stat = SHIP_STAT_LOST;

	/* }bv̐ݒ */
	map_init();

	/* wi̐ݒ */
	background_init();

	/* BGM̍Đ */
	sound_music(BGM_SCRAMBLE, -1);

	return 0;
}

/* XV */
void Update(void) {

	/* ͑u̓ǂݍ */
	input_read();

	if (input[P1] & INPUT_KEYDOWN_START) {
		Uint32 mode = system_info.status & SYSTEM_MODE_MASK;

		switch (mode) {
		case SYSTEM_MODE_READY:
		case SYSTEM_MODE_OVER:
			/* Q[JnAĊJ */
			restart();
			break;

		case SYSTEM_MODE_PAUSE:
			/* |[Y@\̉ */
			system_info.status &= ~SYSTEM_MODE_PAUSE;
			break;

		default:
			/* |[Y@\̐ݒ */
			system_info.status |= SYSTEM_MODE_PAUSE;
			break;
		}
	}

	if ((system_info.status & SYSTEM_MODE_MASK) != SYSTEM_MODE_PAUSE) {

		/* \XvCgj */
		sprite_clean();

		/* wĩXN[ */
		if (-bg[1].cnt_x >= BG_MAP_SIZE) {

			SURFACE *tex = surface_get(TEX_BG1);
			int x, y, w, h;

			w = tex->frame_width / BG_MAP_SIZE;
			h = tex->frame_height / BG_MAP_SIZE;
			bg[1].scroll_x = (bg[1].scroll_x - 1 + w) % w;
			bg[1].cnt_x += BG_MAP_SIZE;
			x = ((bg[1].ofs_x - BG_MAP_SIZE) / BG_MAP_SIZE + BG_MAP_WIDTH + BG_MAP_RESERVE) % (BG_MAP_WIDTH + BG_MAP_RESERVE);

			//fprintf(stderr, "bg[1].ofs_x=%d, x=%d, bg[1].scroll_x=%d\n", bg[1].ofs_x, x, bg[1].scroll_x);

			for (y = 0; y < h; y++) {
				bg[1].map[x + (y + 22) * (BG_MAP_WIDTH + BG_MAP_RESERVE)].map_id = y * w + bg[1].scroll_x;
			}
		}
		if (-bg[2].cnt_x >= BG_MAP_SIZE) {

			SURFACE *tex = surface_get(TEX_BG2);
			int x, y, w, h;

			w = tex->frame_width / BG_MAP_SIZE;
			h = tex->frame_height / BG_MAP_SIZE;
			bg[2].scroll_x = (bg[2].scroll_x - 1 + w) % w;
			bg[2].cnt_x += BG_MAP_SIZE;
			x = ((bg[2].ofs_x - BG_MAP_SIZE) / BG_MAP_SIZE + BG_MAP_WIDTH + BG_MAP_RESERVE) % (BG_MAP_WIDTH + BG_MAP_RESERVE);

			//fprintf(stderr, "bg[2].ofs_x=%d, x=%d, bg[2].scroll_x=%d\n", bg[2].ofs_x, x, bg[2].scroll_x);

			for (y = 0; y < h; y++) {
				bg[2].map[x + (y + 13) * (BG_MAP_WIDTH + BG_MAP_RESERVE)].map_id = y * w + bg[2].scroll_x;
			}
		}
		if (-bg[3].cnt_x >= BG_MAP_SIZE) {

			SURFACE *tex = surface_get(TEX_BG1);
			int width = tex->frame_width / BG_MAP_SIZE;
			int x, y;

			bg[3].scroll_x = (bg[3].scroll_x - 1 + width) % width;
			bg[3].cnt_x += BG_MAP_SIZE;
			x = ((bg[3].ofs_x - BG_MAP_SIZE) / BG_MAP_SIZE + BG_MAP_WIDTH + BG_MAP_RESERVE) % (BG_MAP_WIDTH + BG_MAP_RESERVE);

			//fprintf(stderr, "bg[3].ofs_x=%d, x=%d, bg[3].scroll_x=%d\n", bg[3].ofs_x, x, bg[3].scroll_x);

			for (y = 0; y < BG_MAP_HEIGHT + BG_MAP_RESERVE; y++) {
				bg[3].map[x + y * (BG_MAP_WIDTH + BG_MAP_RESERVE)].map_id = y * width + bg[3].scroll_x;
			}
		}

		/* TODO : Qjwi𓮂B */
		bg_scroll(1, -4, 0); /**/
		bg_scroll(2, -2, 0); /**/
		bg_scroll(3, -1, 0); /**/

		/* }bv̐ */
		if (!(system_info.status & SYSTEM_MODE_MASK)) {
			map_action();
		}

		/* @Vbg̐ */
		system_info.score += shot_action(&ship_shot_mgr, &enemy_mgr);
		system_info.score += shot_action(&ship_shot2_mgr, &enemy_mgr);
		system_info.score += shot_action(&ship_shot3_mgr, &enemy_mgr);
		system_info.score += shot_action(&ship_missile_mgr, &enemy_mgr);

		/* G@Vbg̐ */
		system_info.score += shot_action(&enemy_shot_mgr, &ship_mgr);

		/* @̐ */
		myship_action(&myship_mgr);

		/* G@̐ */
		enemy_action(&enemy_mgr, &enemy_shot_mgr, myship_mgr.ship);

		/* ʌʂ̐ */
		effect_action();

		/* XRA\ */
		font_locate(0, 0, 0);
		font_printf(0, "SCORE:%08d  LEVEL:%02d", system_info.score, system_info.level);
	}

	++system_info.frame;
}

/* `悷 */
void Draw(void) {

	if(SDL_MUSTLOCK(screen)) {
		if(SDL_LockSurface(screen) < 0) return;
	}

	/* TODO : Pjʂ\B */
	/* wiƃXvCg`悷 */
	bg_rendaring(screen, 3);
	bg_rendaring(screen, 2);
	sprite_rendering(screen);
	bg_rendaring(screen, 0);
	bg_rendaring(screen, 1);
	system_info_draw(screen);

	if(SDL_MUSTLOCK(screen)) {
		SDL_UnlockSurface(screen);
	}

	/* ʂXV */
	SDL_Flip(screen);
}

/* C[v */
void MainLoop(void) {

	SDL_Event event;
	double next_frame = SDL_GetTicks();
	double wait = 1000.0 / 60;

	for (;;) {
		/* ׂẴCxg */
		while (SDL_PollEvent(&event)) {
			/* QUIT Cxg邩AESC L[ꂽI */
			if ((event.type == SDL_QUIT) ||
				(event.type == SDL_KEYUP && event.key.keysym.sym == SDLK_ESCAPE))
				return;
		}

		/* 1bԂ60Update悤ɂ */
		if (SDL_GetTicks() >= next_frame) {
			Update();

			/* Ԃ܂ƂDraw */
			//if (SDL_GetTicks() < next_frame + wait)
				Draw();
			next_frame += wait;
			//SDL_Delay(0);
		}
	}
}


/* Is */
void Finalize(void) {

	bg_free();
	surface_free();
	sound_free();
	input_free();

	/* I */
	SDL_Quit();
}


/* C֐ */
int SDL_main(int argc, char* argv[]) {

	typedef struct OPTION_INFO {
		char*  command;
		Uint32 value;
	} OPTION_INFO;

	const static OPTION_INFO options[] = {
		{"-v"      , SYSTEM_OPT_VERBOSE},
		{"-f"      , SYSTEM_OPT_FULLSCREEN},
		{"--full"  , SYSTEM_OPT_FULLSCREEN},
		{"-w"      , SYSTEM_OPT_WIDESCREEN},
		{"--wide"  , SYSTEM_OPT_WIDESCREEN},
		{"--easy"  , SYSTEM_OPT_LEVEL|SYSTEM_OPT_EASY  },
		{"--normal", SYSTEM_OPT_LEVEL|SYSTEM_OPT_NORNAL},
		{"--hard"  , SYSTEM_OPT_LEVEL|SYSTEM_OPT_HARD  },
		{"--super" , SYSTEM_OPT_LEVEL|SYSTEM_OPT_SUPER },
		{"--hyper" , SYSTEM_OPT_LEVEL|SYSTEM_OPT_HYPER },
	};

	memset(&system_info, 0, sizeof(system_info));

	if (argc > 1) {
		int i;

		for (i = 1; i < argc; i++) {
			char *cmd = argv[i];
			int j;

			if (!strcmp("--help", cmd)) {
				printf("Usage: %s [options]\n"
					   "Options: -v        Verbose mode\n"
					   "         -f or --full Full screen mode\n"
					   "         -w or --wide Wide screen mode\n"
					   "         --easy    Level easy\n"
					   "         --normal  Level normal (default)\n"
					   "         --hard    Level hard\n"
					   "         --super   Level super\n"
					   "         --hyper   Level hyper\n");
				return EXIT_SUCCESS;
			}

			for (j = NUMBEROF(options) - 1; j >= 0 ; j--) {
				const OPTION_INFO *opt = &options[j];

				if (!strcmp(opt->command, cmd)) {
					system_info.options |= opt->value;
					break;
				}
			}

			if (j < 0) {
				fprintf(stderr, "Illegal option: %s\n", cmd);
				return EXIT_FAILURE;
			}
		}
	}

	if (Initialize() < 0)
		return EXIT_FAILURE;

	MainLoop();
	Finalize();

	return EXIT_SUCCESS;
}
/*----------------------------------------------------------------------------*/
/* lower ȏ upper ȉ̗Ԃ */
double Random(double lower, double upper) {
	return ((double)rand() / RAND_MAX) * (upper - lower) + lower;
}

/* Pʉ~̍Wpx߂ */
double angle(double x, double y) {
/*
	double s = sqrt(x * x + y * y);
	double result = (s != 0) ? asin(x / s) / M_PI * 180: 0;
	if (y < 0) result = 360 - result;
	return result;
*/
#if 1
	double result = 0;

	if (x == 0) {
		if (y < 0) result = 180;

	} else {
		double s = sqrt(x * x + y * y);

		if (s != 0) {
			result = asin(x / s) / M_PI * 180;
		}
		if (x < 0) result = 360 + result;
	}
	return result;
#endif
#if 0
	double result = 0;

	if (x == 0) {
		/* XW0̂Ƃ */
		if (y > 0) {
			/* YŴƂ */
			result = M_PI / 2;
		} else if (y < 0) {
			/* YŴƂ */
			result = M_PI * 3 / 2;
		}
	} else {
		/* XW0ȊÔƂ */
		double tan = y / fabs(x); /* tanlvZ  */
		result = atan(tan);       /* atanl擾 */
		if (x < 0) {
			/* XŴƂ */
			result = M_PI - result;
		} else {
			/* XŴƂ */
			if (y < 0) {
				/* YŴƂ */
				result = 2 * M_PI + result;
			}
		}
	}

	return result / M_PI * 180;
#endif
}

char *format(const char *format, ...) {

	static char buf[1024];

	va_list ap;
	va_start(ap, format);
	vsnprintf(buf, sizeof(buf), format, ap);
	va_end(ap);

	return buf;
}

void report(const char *file, const int line, const char *message) {

	if (system_info.options & SYSTEM_OPT_VERBOSE) {
		printf("%s(%d) %s\n", file, line, message);
	}
}
/*----------------------------------------------------------------------------*/
/* wȉ */
void background_init(void) {

	SURFACE *tex;
	int x, y, w, h;

	tex = surface_get(TEX_BG3);
	w = tex->frame_width / BG_MAP_SIZE;

	for (y = 0; y < BG_MAP_HEIGHT + BG_MAP_RESERVE; y++) {
		MAP_ATTR *line = &bg[3].map[y * (BG_MAP_WIDTH + BG_MAP_RESERVE)];
		for (x = 0; x < BG_MAP_WIDTH + BG_MAP_RESERVE; x++) {
			line[x].surface_id = TEX_BG3;
			line[x].map_id = y * w + x;
		}
	}

	tex = surface_get(TEX_BG2);
	w = tex->frame_width / BG_MAP_SIZE;
	h = tex->frame_height / BG_MAP_SIZE;

	for (y = 0; y < h; y++) {
		MAP_ATTR *line = &bg[2].map[(y + 13) * (BG_MAP_WIDTH + BG_MAP_RESERVE)];
		for (x = 0; x < BG_MAP_WIDTH + BG_MAP_RESERVE; x++) {
			line[x].surface_id = TEX_BG2;
			line[x].map_id = y * w + x;
		}
	}

	tex = surface_get(TEX_BG1);
	w = tex->frame_width / BG_MAP_SIZE;
	h = tex->frame_height / BG_MAP_SIZE;

	for (y = 0; y < h; y++) {
		MAP_ATTR *line = &bg[1].map[(y + 22) * (BG_MAP_WIDTH + BG_MAP_RESERVE)];
		for (x = 0; x < BG_MAP_WIDTH + BG_MAP_RESERVE; x++) {
			line[x].surface_id = TEX_BG1;
			line[x].map_id = y * w + x;
		}
	}
}

/* ăX^[g */
void restart(void) {
	system_info.status = 0;
	system_info.score  = 0;
	system_info.frame  = 0;

	ship_init(&ship_mgr, ships, NUMBEROF(ships));
	ship_init(&enemy_mgr, enemy, NUMBEROF(enemy));
	shot_init(&ship_shot_mgr, ship_shot, NUMBEROF(ship_shot));
	shot_init(&ship_shot2_mgr, ship_shot2, NUMBEROF(ship_shot2));
	shot_init(&ship_shot3_mgr, ship_shot3, NUMBEROF(ship_shot3));
	shot_init(&ship_missile_mgr, ship_missile, NUMBEROF(ship_missile));
	shot_init(&enemy_shot_mgr, enemy_shot, NUMBEROF(enemy_shot));

	myship_init(&myship_mgr);
	map_init();
	effect_clean();
	sound_music(BGM_01, -1);
}

/* VXe̕` */
void system_info_draw(SDL_Surface* screen) {

	/* TODO : Wj^Cg\ */
	const static info_id[] = {-1, TEX_TITLE, TEX_GAMEOVER, TEX_PAUSE};
	int mode = system_info.status & SYSTEM_MODE_MASK;
	int id = info_id[mode];

	if (id >= 0) {
		SURFACE *surface = surface_get(id);
		surface_draw(screen, id, (WIDTH - surface->frame_width) / 2, (HEIGHT - surface->frame_height) / 2);
	}

	if (id != SYSTEM_MODE_READY) {
		SHIP_INFO *ship = myship_mgr.ship;
		int x = WIDTH - 18;
		int y = HEIGHT - 18;

		if (ship->flag & ITEM_FLAG_3WAY) {
			surface_draw(screen, TEX_ICON_PYTHON, x, y);
			x -= 17;
		}
		if (ship->flag & ITEM_FLAG_MISSILE) {
			surface_draw(screen, TEX_ICON_JAVA, x, y);
			x -= 17;
		}
		if (ship->flag & ITEM_FLAG_SPEEDUP) {
			surface_draw(screen, TEX_ICON_RAILS, x, y);
			x -= 17;
		}
		if (ship->flag & ITEM_FLAG_POWERUP) {
			surface_draw(screen, TEX_ICON_RUBY, x, y);
		}
	}
}
/*----------------------------------------------------------------------------*/
