/*
 * shot.h
 *
 * Last modified: <2008/08/27 04:22:34 +0900> By SUMIDA
 */
#ifndef SHOT_H_INCLUDED
#define SHOT_H_INCLUDED

#include "ship.h"

#define SHOT_LIMIT_STRENGTH 100

typedef enum SHOT_ID {

	SHOT_ID_NORMAL = 0,
	SHOT_ID_NORMAL2,
	SHOT_ID_MISSILE,
	SHOT_ID_BALLET,
	SHOT_ID_RAY1,
	SHOT_ID_RAY2,
	SHOT_ID_PHOTON,
	SHOT_ID_MAX

} SHOT_ID;

typedef enum SHOT_STAT {

	SHOT_STAT_LOST = 0,      /*      */
	SHOT_STAT_NORMAL,        /* ʏ */
	SHOT_STAT_SEARCH,        /* T */
	SHOT_STAT_EXPLOSION,     /*      */
	SHOT_STAT_MAX

} SHOT_STAT;

typedef struct SHOT_INFO {

	struct SHOT_INFO *next;
	int id;
	SPRITE sprite;
	SHOT_STAT stat;
	int count;
	int strength;

} SHOT_INFO;

typedef struct SHOT_MGR {
	SHOT_INFO *active;
	SHOT_INFO *pool;
} SHOT_MGR;

extern void shot_init(SHOT_MGR *mgr, SHOT_INFO *infos, size_t number);

extern SHOT_INFO *shot_new(SHOT_MGR *mgr, SHOT_ID id);

extern void shot_delete(SHOT_MGR *mgr, SHOT_INFO *info, SHOT_INFO *prev);

extern int shot_action(SHOT_MGR *mgr, SHIP_MGR *ship_mgr);

extern void shot_fire(SHOT_INFO *info, SHIP_INFO *ship, Real ox, Real oy);

extern void shot_homing(SPRITE *info, SPRITE *ship, Real speed);

#endif
