/*
 * sprite.h
 *
 * Last modified: <2008/08/08 07:04:35 +0900> By SUMIDA
 */
#ifndef SPRITE_H_INCLUDED
#define SPRITE_H_INCLUDED

#include "real.h"
#include "surface.h"

/* XvCg */
#define SPRITE_MAX 10000

/* IvVrbgATC */
#define SPRITE_VISIBLE      	0x00010000
#define SPRITE_USE_COLLISION	0x00020000
#define SPRITE_USE_MOVE     	0x00040000
#define SPRITE_USE_ANIME    	0x00080000
#define SPRITE_USE_ALPHA    	0x00100000
#define SPRITE_USE_LOWER     	0x00200000
#define SPRITE_LOOP_ANIME   	0x00400000
#define SPRITE_STOP_ANIME   	0x00800000
#define SPRITE_FRAME        	0x01000000
#define SPRITE_FRAME8       	0x02000000
#define SPRITE_FRAME16      	0x03000000
#define SPRITE_FRAME32      	0x04000000
#define SPRITE_FRAME48      	0x05000000
#define SPRITE_FRAME64      	0x06000000

/* IvV}XN */
#define SPRITE_MSK_FRAME    	0xff000000
#define SPRITE_MSK_PRIORITY 	0x000000ff
#define SPRITE_MSK_ALPHA    	0x0000ff00

/* IvVVtg */
#define SPRITE_SFT_FRAME    	24
#define SPRITE_SFT_ALPHA    	8

/* XvCg */
typedef struct {

	int surface_id;    		/* T[tFXID       */
	int frame_no;      		/* t[ԍ       */
	Uint32 options;    		/* IvV     */
	Real x;            		/* \ʒu         */
	Real y;            		/* \ʒu         */
	int move_interval; 		/* ړԊu           */
	int move_counter;  		/* ړJE^       */
	Real dx;           		/* ړʂ           */
	Real dy;           		/* ړʂ           */
	int frame_start;   		/* AjJnt[ */
	int frame_end;     		/* AjIt[ */
	int frame_interval;		/* t[JڊԊu   */
	int frame_counter; 		/* t[JE^   */
	RealRect collision;		/* 蔻`     */

} SPRITE;

extern void sprite_init(void);
extern void sprite_clean(void);
extern void sprite_put(SPRITE* sprite);
extern void sprite_rendering(SDL_Surface* screen);
extern void sprite_draw(SDL_Surface* screen, SPRITE* sprite);
extern void sprite_action(SPRITE* sprite);
extern SDL_bool sprite_collision_check(SPRITE* s0, SPRITE* s1);
extern double sprite_get_angle(SPRITE *s0, SPRITE *s1);
extern void sprite_set_angle(SPRITE *s, double angle, Real speed);
extern void sprite_set_pos(SPRITE *spr1, SPRITE *spr2, Real ox, Real oy);

#endif
