/*
 * surface.h
 *
 * Last modified: <2008/08/01 05:53:04 +0900> By SUMIDA
 */
#ifndef SURFACE_H_INCLUDED
#define SURFACE_H_INCLUDED

#define SURFACES_MAX 256

typedef struct {
	SDL_Surface *surface;
	int frame_width;
	int frame_height;
} SURFACE;

extern void surface_init(void);

extern SDL_Surface *surface_load(const char *name, int id);

extern void surface_trash(int id);

extern void surface_free(void);

extern void surface_set_frame(int id, int width, int height);

extern void surface_set_alpha(int id, Uint8 alpha);

extern void surface_reset_alpha(int id);

extern void surface_draw(SDL_Surface *screen, int id, int x, int y);

extern void surface_draw_frame(SDL_Surface *screen, int id, int frame, int x, int y);

extern void surface_draw_frame8(SDL_Surface *screen, int id, int frame, int x, int y);

extern void surface_draw_frame16(SDL_Surface *screen, int id, int frame, int x, int y);

extern void surface_draw_frame32(SDL_Surface *screen, int id, int frame, int x, int y);

extern void surface_draw_frame48(SDL_Surface *screen, int id, int frame, int x, int y);

extern void surface_draw_frame64(SDL_Surface *screen, int id, int frame, int x, int y);

extern SURFACE *surface_get(int id);

extern SDL_bool surface_is_exists(int id);

enum {
	FUNCID_SURFACE_DRAW = 0,
	FUNCID_SURFACE_DRAW_8,
	FUNCID_SURFACE_DRAW_16,
	FUNCID_SURFACE_DRAW_32,
	FUNCID_SURFACE_DRAW_48,
	FUNCID_SURFACE_DRAW_64,
	FUNCID_SURFACE_DRAW_MAX
};

typedef void(*FUNC_SURFACE_DRAW)(SDL_Surface*,int,int,int,int);
extern FUNC_SURFACE_DRAW func_surface_draw[];

#endif
